* NEWS: du --one-file-system (-x) would skip subdirectories of any
authorJim Meyering <jim@meyering.net>
Sun, 3 Dec 2006 10:17:35 +0000 (11:17 +0100)
committerJim Meyering <jim@meyering.net>
Sun, 3 Dec 2006 10:17:35 +0000 (11:17 +0100)
directory listed as second or subsequent command line argument.
* tests/du/one-file-system: New file.  Test for today's fts.c fix.
* tests/du/Makefile.am (TESTS): Add one-file-system.

ChangeLog
NEWS
tests/du/Makefile.am
tests/du/one-file-system [new file with mode: 0755]

index 94db40d..1d4eb33 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+2006-12-03  Jim Meyering  <jim@meyering.net>
+
+       * NEWS: du --one-file-system (-x) would skip subdirectories of any
+       directory listed as second or subsequent command line argument.
+       * tests/du/one-file-system: New file.  Test for today's fts.c fix.
+       * tests/du/Makefile.am (TESTS): Add one-file-system.
+
 2006-12-02  Jim Meyering  <jim@meyering.net>
 
        * tests/du/basic: Generate 4KB file simply using printf, rather than
diff --git a/NEWS b/NEWS
index 3493041..92de634 100644 (file)
--- a/NEWS
+++ b/NEWS
@@ -2,6 +2,11 @@ GNU coreutils NEWS                                    -*- outline -*-
 
 * Noteworthy changes in release 6.7-pre (????-??-??) [?]
 
+** Bug fixes
+
+  du --one-file-system (-x) would skip subdirectories of any directory
+  listed as second or subsequent command line argument.
+
 
 * Noteworthy changes in release 6.6 (2006-11-22) [stable]
 
index e766eb5..e547b6b 100644 (file)
@@ -21,6 +21,7 @@
 AUTOMAKE_OPTIONS = 1.4 gnits
 
 TESTS = \
+  one-file-system \
   inacc-dest \
   long-from-unreadable \
   long-sloop \
diff --git a/tests/du/one-file-system b/tests/du/one-file-system
new file mode 100755 (executable)
index 0000000..b595dc6
--- /dev/null
@@ -0,0 +1,61 @@
+#!/bin/sh
+# Test for a bug in fts's handling of FTS_XDEV, the flag behind
+# du's --one-file-system (-x) option.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  du --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p b/c y/z || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+fail=0
+
+# Due to a used-uninitialized variable, the "du -x" from coreutils-6.6
+# would not traverse into second and subsequent directories listed
+# on the command line.
+du -ax b y > t || fail=1
+sed 's/^[0-9][0-9]*    //' t > out
+cat <<\EOF > exp || fail=1
+b/c
+b
+y/z
+y
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail